#ifndef _KILIB_KTL_GAP_H
#define _KILIB_KTL_GAP_H
namespace kilib{


//-------------------------------------------------------------------------
//@{
//	Mbvobt@
//
//	ɋ񂾃Mbvobt@Ƃ́B
//	̂ႢĕʕłĂ邩܂񂪁A
//	ׂƂ͂܂CɂȂłB
//
//	ẑ悤Ƀ_ANZX\A
//	ӏւ̘A}/폜Ƃf[^\łB
//
//	C[Ŵ܂܃Rs[ĂȂ̂ŁA
//	v~eBu^ȊOł͎gȂƁB
//@}
//-------------------------------------------------------------------------


//  L  <--0
//  L
//  |  <--gS
//  |
//  L  <--gE
//  L
//     <--End;


template<class T>
class gapbuf
{
public:

	//@{
	//	RXgN^
	//	@param alloc_size mۂ鏉TCYB
	//@}
	explicit gapbuf( ulong alloc_size=40 )
		{
			m_pData = new T[ alloc_size ];
			gS = 0;
			gE = End = alloc_size;
		}

	//@{
	//	fXgN^
	//@}
	~gapbuf()
		{ delete [] m_pData; }

	//@{ z̗vf𓾂 //@}
	ulong size() const
		{ return End - (gE-gS); }

	//@{ vf擾 //@}
	T& operator[]( ulong i )
		{ return m_pData[ ( i<gS ) ? i : i+(gE-gS) ]; }

	//@{ vf擾 //@}
	const T& operator[]( ulong i ) const
		{ return m_pData[ ( i<gS ) ? i : i+(gE-gS) ]; }

	//@{ vf擾 //@}
	T& get( ulong i )
		{ return m_pData[ ( i<gS ) ? i : i+(gE-gS) ]; }

	//@{ vf擾 //@}
	const T& get( ulong i ) const
		{ return m_pData[ ( i<gS ) ? i : i+(gE-gS) ]; }

	//@{ ɗvfǉ //@}
	void Add( const T& x )
		{ InsertAt( size(), x ); }

	//@{ ɗvfǉ //@}
	void Add( const T* x, ulong len )
		{ InsertAt( size(), x, len ); }

	//@{ vf} //@}
	void InsertAt( ulong i, const T& x )
		{
			MakeGapAt( i );
			m_pData[gS++] = x;
			if( gS==gE )
				Reallocate();
		}

	//@{ vf} //@}
	void InsertAt( ulong i, const T* x, ulong len )
		{
			MakeGapAt( i );
			while( gE-gS <= len )
				Reallocate();
			memcpy( m_pData+gS, x, len*sizeof(T) );
		}

	//@{ vf폜 //@}
	void RemoveAt( ulong i )
		{
			if( i==gS-1 )
				gS--;
			else
			{
				MakeGapAt( i );
				gE++;
			}
		}

	//@{
	//	SvffXgNg
	//@}
	void Clear()
		{
			gS = 0;
			gE = End;
		}

protected:

	void MakeGapAt( ulong i )
	{
		if( i<gS )
		{
			gE -= (gS-i);
			memmove( m_pData+gE, m_pData+i, (gS-i)*sizeof(T) );
			gS = i;
		}
		else if( i>gS )
		{
			int j = i+(gE-gS);
			memmove( m_pData+gS, m_pData+gE, (j-gE)*sizeof(T) );
			gE = j;
			gS = i;
		}
	}

	void Reallocate()
	{
		T *tmp = new T[End*2], *old=m_pData;
		memcpy( tmp, old, gS*sizeof(T) );
		memcpy( tmp+End+gE, old+gE, (End-gE)*sizeof(T) );
		delete [] old;

		m_pData = tmp;
		gE     = End+gE;
		End   *= 2;
	}

protected:

	T*    m_pData;
	ulong End;
	ulong gS;
	ulong gE;
};


//-------------------------------------------------------------------------
//@{
//	gapbuf + autoptr ̂ӂ
//@}
//-------------------------------------------------------------------------


template<class T>
class gapbufptr : public gapbuf<T*>
{
public:
	explicit gapbufptr( ulong alloc_size=40 )
		: gapbuf<T*>( alloc_size )
		{
		}

	~gapbufptr()
		{
			Clear();
		}
	void RemoveAt( ulong i )
		{
			delete get(i);
			gapbuf<T*>::RemoveAt( i );
		}
	void Clear()
		{
			ulong i, ed=gS;
			for( i=0; i<ed; i++ )
				delete m_pData[i];
			ed=End;
			for( i=gE; i<ed; i++ )
				delete m_pData[i];
			gapbuf<T*>::Clear();
		}

private:
	gapbufptr<T>& operator=( const gapbufptr<T>& o );
};


//-------------------------------------------------------------------------


};     // namespace kilib
#endif // _KILIB_KTL_GAP_H
